//+------------------------------------------------------------------+
//|                                                  Crossbow #1.mq4 |
//|                                        code by Alex.Piech.FinGeR |
//|                                        http://www.forex-tsd.com  |
//|                                                                  |
//|                                                                  |
//|Strategic Swiss Franc  Version 1.0                                |
//|Trading System  by Chuck Le Beau's                                |  
//|                                                                  |
//+------------------------------------------------------------------+


#property copyright "Alex.Piech.FinGeR"
#property link      "http://www.forex-tsd.com"
#define   MAGIC      20051110

extern string PARAMETERS_TRADE = "PARAMETERS TRADE";
extern int    SLIPPAGE       = 3; 
extern double Lots           = 0.1;    
    
int    TakeProfit     = 1000;     
int    StopLoss       = 50;

extern string PARAMETERS_EXPERT = "PARAMETERS EXPERT";
extern bool   UseOneAccount = False;    
extern int    NumberAccount = 0815;   
extern string Name_Expert   = "Brainwashing #1a";
extern bool   UseSound      = True;         
extern string NameFileSound = "expert.wav"; 
extern color  clOpenBuy     = LightBlue;    
extern color  clOpenSell    = LightCoral;  
extern color  clModifyBuy   = Aqua;         
extern color  clModifySell  = Tomato;       
extern color  clCloseBuy    = Blue;         
extern color  clCloseSell   = Red;          

int prevBar; 



void deinit() 
{
  Comment("");
}


void start()
 {
 
Comment("Welcome Strategic Swiss Franc - Crossbow - Daily"); 


if (Period()!=1440) 
{
Comment("!!! EA STOP failed Periode D1 !!!");

return(0);
}




Comment("");



 
 if (UseOneAccount && AccountNumber()!=NumberAccount) {
    Comment("-UseOnAccount- Number"+AccountNumber()+" FAILED!");
    return;
  } else Comment("");



CheckForOpen();
CheckForClose();
CheckForTrail();   


}



void CheckForOpen() {

double ldStop=0, ldTake=0;

if (!ExistPosition() && prevBar!=Bars) {
    
   
     if (iCCI(NULL,1440,12,5,1) > 170 && iCCI(NULL,1440,12,5,2) < 170 ) {
      
      if (StopLoss!=0) ldStop=Low[Lowest(NULL,1440,MODE_LOW,24 ,0)];
      
      if (TakeProfit!=0) ldTake=Ask+TakeProfit*Point;
      SetOrder(OP_BUY, Ask, ldStop, ldTake);
      
      prevBar=Bars;
      
   
   
    }
   
    if (iCCI(NULL,1440,12,5,1) > -170 && iCCI(NULL,1440,12,5,2) < -170) {
     
      if (StopLoss!=0) ldStop=High[Highest(NULL,1440,MODE_HIGH,24 ,0)];
      
      if (TakeProfit!=0) ldTake=Bid-TakeProfit*Point;
      SetOrder(OP_SELL, Bid, ldStop, ldTake);
      prevBar=Bars;
   
    }
  }




}




//+------------------------------------------------------------------+
//| is MAGIC trade open ?                                            | 
//+------------------------------------------------------------------+
bool ExistPosition() {
  bool Exist=False;
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) Exist=True;
    }
  }
  return(Exist);
}




void SetOrder(int op, double pp, double ldStop, double ldTake) {
  color  clOpen;
  string lsComm=GetCommentForOrder();
  if (op==OP_BUY) clOpen=clOpenBuy; else clOpen=clOpenSell;
  OrderSend(Symbol(),op,Lots,pp,SLIPPAGE,ldStop,ldTake,lsComm,MAGIC,0,clOpen);
  if (UseSound) PlaySound(NameFileSound);
}





string GetCommentForOrder() {
  return(Name_Expert);
}



void CheckForTrail() {
  
  bool fs=False;  
  bool fs1=False;  
  
double c=iClose(NULL,PERIOD_D1,0); 
double ADX=iADX(NULL,1440,14,PRICE_CLOSE,MODE_MAIN,0);
double ATR=iATR(NULL,1440,25,0);
double ExitLong; 
double ExitShort;


for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
     
        if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC ) {
          if (OrderType()==OP_BUY) {

bool   fm;
double ldOpen=OrderOpenPrice();
double ldTake=OrderTakeProfit();  
ExitLong=OrderStopLoss();          
if (c > 3 * ATR + OrderOpenPrice() ) ExitLong=Low[Lowest(NULL,1440,MODE_LOW,10,0)];  //L3/10Ch
if {MaxTradeHigh >= OrderOpenPrice() + 4 * ATR )  ExitLong = OrderOpenPrice() + 2 * ATR; //L2Atr
if (c > 6 * ATR + OrderOpenPrice() ) ExitLong=Low[Lowest(NULL,1440,MODE_LOW,4,0)]; //L6/4Ch
if (MaxTradeClose >  OrderOpenPrice() + 1 * ATR && MaxTradeClose > MaxTradeClose[3] && ADX < iADX(NULL,1440,14,PRICE_CLOSE,MODE_MAIN,3) ) ExitLong=Low[Lowest(NULL,1440,MODE_LOW,1,0)];//"LDev 
 
fm=OrderModify(OrderTicket(), ldOpen, ExitLong, ldTake, 0, clModify);
if (!fm) Print("!!! ExitLong Order Modify... ERROR !!!");

}


if (OrderType()==OP_SELL) {
bool   fm;
double ldOpen=OrderOpenPrice();
double ldTake=OrderTakeProfit(); 
ExitShort=OrderStopLoss();



if (c > OrderOpenPrice()-3* ATR ) ExitShort=High[Highest(NULL,1440,MODE_HIGH,10,0)];  //S3/10Ch
if {MinTradeLow <= OrderOpenPrice() - 4 * ATR )  ExitShort = OrderOpenPrice() - 2 * ATR; //S2Atr
if (c < OrderOpenPrice()-6* ATR) ExitShort=High[Highest(NULL,1440,MODE_HIGH,4,0)]; //S6/4Ch
if (MinTradeClose <  OrderOpenPrice() - 1 * ATR && MinTradeClose < MinTradeClose[5] && ADX < iADX(NULL,1440,14,PRICE_CLOSE,MODE_MAIN,5) ) ExitShort=High[Highest(NULL,1440,MODE_HIGH,5,0)];//"SDev 
          
          
fm=OrderModify(OrderTicket(), ldOpen, ExitShort, ldTake, 0, clModify);
if (!fm) Print("!!! ExitShort Order Modify... ERROR !!!");
              }
            }
          }
        }
      }
    }
  }



 
 
void CheckForClose() {
  
  bool fs=False;  
  bool fs1=False;  
 
if (iCCI(NULL,1440,12,5,1) > 170 && iCCI(NULL,1440,12,5,2) < 170 ) fs1 = True;
 
if (iCCI(NULL,1440,12,5,1) > -170 && iCCI(NULL,1440,12,5,2) < -170) fs = True;

 
for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
        if (OrderType()==OP_BUY && fs) {
          OrderClose(OrderTicket(), Lots, Bid, SLIPPAGE, Aqua);
          return;
        }
        if (OrderType()==OP_SELL && fs1) {
          OrderClose(OrderTicket(), Lots, Ask, SLIPPAGE, Violet);
          return;
        }
      }
    }
  }
}

















































































































































